/*****************************************************************************
 * $RCSfile: BTeamTypes.hh,v $
 * Copyright 2001,2002 Matthias Seekamp, Andreas Daniel, Daniel Stephan,
 *                     Jens Meyer, Robert Adolph
 * 
 * This file is part of BUGSAgent2002
 *
 * BUGSAgent2002 is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * BUGSAgent2002 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BUGSAgent2002; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *-CVS-Info:-----------------------------------------------------------------
 * Currently locked by: $Locker:  $
 *
 * Last changed:
 * ------------------------------
 * $Author: fastjack $
 * $Date: 2002/04/05 16:15:42 $
 * $Revision: 1.7 $
 *****************************************************************************/

#ifndef _BTEAMTYPES_HH_
#define _BTEAMTYPES_HH_

namespace cmu 
{
  class Vector;
}


enum ActionType {
  ACTION_unknown, ACTION_run, ACTION_kick, ACTION_dribble,ACTION_getball, ACTION_move
};


struct Action {
  ActionType type;
  float x;
  float y;
  int pf_x;
  int pf_y;
  int strength;
  bool valid; // ignorier mich
  
  Action() : valid(false) {}
  Action(int action[]);
  Action(const cmu::Vector & v);
};


struct PlayerInterceptionInfo {
  float distance;
  char side;
  bool isUnableToIntercept;

  PlayerInterceptionInfo();
  PlayerInterceptionInfo(char s,float d) : distance(d),side(s),isUnableToIntercept(false) {};
};


// Action * neuesActionObj = new Action(ActionArray);

// vector<Action *> actions;
// actions.push_back(neuesActionObj);
// return actions;

#endif

/*
 * $Log: BTeamTypes.hh,v $
 * Revision 1.7  2002/04/05 16:15:42  fastjack
 * kleinere Optimierungen
 *
 * Revision 1.6  2002/04/04 20:37:44  fastjack
 * bug fix
 *
 * Revision 1.5  2002/03/04 14:39:47  seekamp
 * PotentialField gibt jetzt eine Liste von Aktionen zurueck und nicht nur einen Int-Wert
 *
 * Revision 1.4  2002/03/04 12:38:24  fastjack
 * Beispiel code in BTeamTypes.hh
 *
 * Revision 1.3  2002/03/01 11:18:45  fastjack
 * GPL added
 *
 * Revision 1.2  2002/01/30 13:05:30  seekamp
 * move-Befehl des Torwarts vorm Abschlag eingefuehrt
 *
 * Revision 1.1  2002/01/22 11:01:55  fastjack
 * BTeamAction refactoring
 *
 */
