/*****************************************************************************
 * $RCSfile: OffensiveMoveBehaviour.hh,v $
 * Copyright 2001,2002 Matthias Seekamp, Andreas Daniel, Daniel Stephan,
 *                     Jens Meyer, Robert Adolph
 *
 * This file is part of BUGSAgent2002
 *
 * BUGSAgent2002 is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * BUGSAgent2002 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BUGSAgent2002; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *-CVS-Info:-----------------------------------------------------------------
 * Currently locked by: $Locker:  $
 *
 * Last changed:
 * ------------------------------
 * $Author: seekamp $
 * $Date: 2002/04/10 13:24:53 $
 * $Revision: 1.5 $
 *
 * TODO: move verbessern
 *
 *****************************************************************************/

#ifndef _OFFENSIVEMOVEBEHAVIOUR_HH
#define _OFFENSIVEMOVEBEHAVIOUR_HH

#include "Behaviour.hh"
#include "dribble.h"

class OffensiveMoveBehaviour : public Behaviour {

  float goalie_x();
  bool isSituation();
  int numberOfOpponentsInRange(float dist);
  void dribbleTo( const cmu::Vector & target, cmu::DRIBBLEMODE mode = cmu::DM_None );

  bool getball;
  int holdball;

  public:
  OffensiveMoveBehaviour() : getball( false ), holdball( 0 ) {};
  virtual bool behave();
  
 
};

#endif

/*
 * $Log: OffensiveMoveBehaviour.hh,v $
 * Revision 1.5  2002/04/10 13:24:53  seekamp
 * Dribbling/Schuss verbessert.
 * Steilpaesse werden weniger hart gespielt.
 * Wenn aussen wird Richtung, Eckfahne gedribbelt
 *
 * Revision 1.4  2002/04/09 19:23:14  fastjack
 * Verbesserungen der Dribble und Torschuss Methoden. Bug fixes.
 *
 * Revision 1.3  2002/04/09 00:33:28  fastjack
 * bug fix
 *
 * Revision 1.2  2002/04/08 13:28:53  fastjack
 * Dribble-Behaviour verbessert
 *
 * Revision 1.1  2002/04/05 16:18:46  fastjack
 * OffensiveMoveBehaviour implemented. Under certain conditions ( which still may/should be improved ) our agent should dribble forward instead of shooting.
 *
 */
