/*****************************************************************************
 * $RCSfile: PFieldLogger.hh,v $
 * Copyright 2001,2002 Matthias Seekamp, Andreas Daniel, Daniel Stephan,
 *                     Jens Meyer, Robert Adolph
 * 
 * This file is part of BUGSAgent2002
 *
 * BUGSAgent2002 is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * BUGSAgent2002 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BUGSAgent2002; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *-CVS-Info:-----------------------------------------------------------------
 * Currently locked by: $Locker:  $
 *
 * Last changed:
 * ------------------------------
 * $Author: jens $
 * $Date: 2002/03/12 15:45:30 $
 * $Revision: 1.10 $
 *****************************************************************************/

#ifndef PFIELDLOGGER_HH
#define PFIELDLOGGER_HH

//#include "PotentialField.hh"
#include <iostream>
#include <fstream>

class PotentialField;

struct ObjectEntry {
  int unum;
  int x;
  int y;
  int dir;

  ObjectEntry() : unum(-1),x(-1),y(-1),dir(-1) {};

  friend std::ostream & operator<<(std::ostream & os, const ObjectEntry &oe);

};

struct PFEntry {
  int gametime; // Zyklus-Nummer
  int playmode;
  int xRes;
  int yRes;
  ObjectEntry teammates[10];
  ObjectEntry opponents[11];
  ObjectEntry ball;
  ObjectEntry self;
  int xTarget;
  int yTarget;
  int tactic;
  int direction;
  int action;
  int stamina;
  int teampart;
  int situation; // Ballbesitz
  int closestPlayer;
  int pfValues[90][60];

  PFEntry();

  friend std::ostream & operator<<(std::ostream & os, const PFEntry &pfe);
};


class PFieldLogger {
  //
  static PFieldLogger instance;
  std::ofstream of;
  char filename[20];
  bool enabled;
  bool initialized;

  PFEntry* entries[3000];
  int count;
  int fileCounter;

  PFieldLogger();
  void init();

  public:
  static PFieldLogger & getInstance();
  void log(PotentialField* potentialField);
  void flush(bool b);
   void flush(bool b, int unum);
  void setEnabled(bool b);

  PFEntry * createEntryFromPotentialField(PotentialField * field);

};


#endif //PFIELDLOGGER_HH


/*
 * $Log: PFieldLogger.hh,v $
 * Revision 1.10  2002/03/12 15:45:30  jens
 * Grundlage fuer das Lernen der Prioritaeten implementiert. Fehler dabei ausgemerzt und Algorithmus fuer das Lernen auf Papier konkretesiert.
 *
 * Revision 1.9  2002/03/01 11:18:47  fastjack
 * GPL added
 *
 * Revision 1.8  2002/02/26 17:59:30  jens
 * weiter am parsen eines eigenen PF gearbeitet. Einbinden in das Weltmodell funzt noch nicht richtig
 *
 * Revision 1.7  2002/02/10 12:19:13  fastjack
 * Habe die Includes angepasst, damit die Header sich so wenig wie mglich
 * gegenseitig includen. Z.T. ersetzt durch forward Deklaration. getPFEntry Methode
 * aus dem PotentialField heraus geholt und in den PFieldLogger gepackt - ist dort
 * sinniger.
 *
 * Revision 1.6  2002/01/29 19:34:00  fastjack
 * Konflikte behoben.
 *
 * Revision 1.5  2002/01/25 17:22:35  fastjack
 * compiles under Linux AND Solaris8 now. so can be run on the sxx machines now.
 *
 * Revision 1.4  2002/01/18 20:11:21  fastjack
 * Das Logging von Potentialfeldern fertig gestellt. Das Logging ist auch
 * ein-/ausschaltbar ( PFieldLogger::getInstance().setEnabled(true) ).
 *
 * Revision 1.3  2002/01/15 16:33:42  fastjack
 * Neue features fuer die Log-Klasse (kann jetzt wie cout etc verwendet werden), und kleinere Verbesserungen fuer den PFieldLogger hinzugefuegt.
 *
 * Revision 1.2  2002/01/15 10:32:48  fastjack
 * bug fixes
 *
 * Revision 1.1  2002/01/15 09:42:08  fastjack
 * Logging Klasse fuer das Abspeichern der Potentialfelder hinzugefuegt.
 *
 */
