/*****************************************************************************
 * $RCSfile: ScoringBehaviour.hh,v $
 * Copyright 2001,2002 Matthias Seekamp, Andreas Daniel, Daniel Stephan,
 *                     Jens Meyer, Robert Adolph
 *
 * This file is part of BUGSAgent2002
 *
 * BUGSAgent2002 is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * BUGSAgent2002 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BUGSAgent2002; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *-CVS-Info:-----------------------------------------------------------------
 * Currently locked by: $Locker:  $
 *
 * Last changed:
 * ------------------------------
 * $Author: jens $
 * $Date: 2002/04/13 07:59:17 $
 * $Revision: 1.8 $
 *
 * TODO: move verbessern
 *
 *****************************************************************************/

#ifndef SCORINGBEHAVIOUR_HH
#define SCORINGBEHAVIOUR_HH

#include "Behaviour.hh"
#include "geometry.h"

namespace cmu
{
  class PlayerObject;
}


class ScoringBehaviour : public Behaviour {
  //


  cmu::Vector goalie_pos();
  float opponentGoalieInterceptionDistance(cmu::Vector goalCorner);
  bool kickToGoalLeftCorner();
  bool isSituation();
  bool isFlankenSituation();
  bool isClosestPlayerToBall();
  bool isNearToTheirGoalie();
  bool isNearToTheirGoal();
  bool isSafeFromOpponent(cmu::Vector target, cmu::PlayerObject * opponent, float radiusFactor=1.0);
  bool isPossibleToScore( cmu::Vector & target );
  bool findTargetPoint( cmu::Vector & target );
  bool isNearToBall();


  //  void startScoring();
  //  void getBall();
  void shoot(const cmu::Vector & target, bool hardest = true);

  cmu::Vector goalCenter;
  cmu::Vector goalRightCorner;
  cmu::Vector goalLeftCorner;
  cmu::Vector FlankenZielPunkt;
  

  bool getball;
  bool scoringInProgress;
  int scoringState;

  static const int GETBALL = 1;
  static const int START = 0;


  void setScoringState( int state ) { scoringState = state; }

  public:
  ScoringBehaviour() :
    goalCenter( 52.0,0.0 ),
    goalRightCorner( 52.0,5.0 ),
    goalLeftCorner( 52.0,-5.0 ),
    FlankenZielPunkt(36.0,0.0),
    scoringInProgress( false ),
    scoringState( START )
  {}

  virtual bool behave();

  bool testbehave();

};



#endif

/*
 * $Log: ScoringBehaviour.hh,v $
 * Revision 1.8  2002/04/13 07:59:17  jens
 * German Open 2002 Edition
 *
 * Revision 1.7  2002/04/10 13:24:53  seekamp
 * Dribbling/Schuss verbessert.
 * Steilpaesse werden weniger hart gespielt.
 * Wenn aussen wird Richtung, Eckfahne gedribbelt
 *
 * Revision 1.6  2002/04/09 19:23:14  fastjack
 * Verbesserungen der Dribble und Torschuss Methoden. Bug fixes.
 *
 * Revision 1.5  2002/04/09 00:27:45  fastjack
 * kick improved
 *
 * Revision 1.4  2002/04/08 17:59:47  fastjack
 * ScoringBehviour reimplemented. Does not work, yet. So don't worry if we don't shoot a goal...
 *
 * Revision 1.3  2002/04/04 15:54:07  seekamp
 * kleinere Veraenderungen am Attack und Shot Behaviour zudem Libero wieder eingefuehrt und Aussenverteidiger bei gegnerischen Angriffen ueber die gegenueberliegende Seite Richtung Mitte gezogen.
 *
 * Revision 1.2  2002/04/02 17:06:51  fastjack
 * Scoring Behaviour ungetesterweise eingebaut.
 *
 * Revision 1.1  2002/04/02 15:58:12  fastjack
 * Various changes. Torwart Abschlag Bugfix. kleinere unbedeutendere Korrekturen.
 *
 */
