/*****************************************************************************
 * $RCSfile: bugsobjects.cc,v $
 * Copyright 2001,2002 Matthias Seekamp, Andreas Daniel, Daniel Stephan,
 *                     Jens Meyer, Robert Adolph
 * 
 * This file is part of BUGSAgent2002
 *
 * BUGSAgent2002 is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * BUGSAgent2002 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BUGSAgent2002; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *-CVS-Info:-----------------------------------------------------------------
 * Currently locked by: $Locker:  $
 *
 * Last changed:
 * ------------------------------
 * $Author: jens $
 * $Date: 2002/03/08 16:24:31 $
 * $Revision: 1.7 $
 *****************************************************************************/

#include "bugsobjects.hh"
#include "PotentialField.hh"

void BasicObject::setXY(float x, float y) {
  // ob dieses Konstrukt funktioniert....... *spannung*
  // Ok, da wir immer mal wieder Werte erhalten, die einfach
  // zu gros sind, wollen wir nun zu grosse Werte auf das
  // Maximal runterbrechen. zusaetzlich gibts eine Ausgabe...
  if(x>PotentialField::ORIGINAL_FIELD_SIZE_X){
    x=PotentialField::ORIGINAL_FIELD_SIZE_X;
  }
  if(x<(PotentialField::ORIGINAL_FIELD_SIZE_X*-1)){
    x=-PotentialField::ORIGINAL_FIELD_SIZE_X;
  }
  if(y>PotentialField::ORIGINAL_FIELD_SIZE_Y){
    y=PotentialField::ORIGINAL_FIELD_SIZE_Y;
  }
  if(y<(PotentialField::ORIGINAL_FIELD_SIZE_Y*-1)){
    y=-PotentialField::ORIGINAL_FIELD_SIZE_Y;
  }

  altesx = this->x;
  altesy = this->y;

  // now set x and make sure that
  this->x = PotentialField::translateX(x);

  if ( this->x < 0 ) 
    this->x = 0;

  if ( this->x >= PotentialField::FIELD_SIZE_X ) 
    this->x = PotentialField::FIELD_SIZE_X;

  this->y = PotentialField::translateY(y);

  if ( this->y < 0 ) 
    this->y = 0;

  if ( this->y >= PotentialField::FIELD_SIZE_Y ) 

    this->y = PotentialField::FIELD_SIZE_Y;
}

void BasicObject::estimate() {
  // WRITE ME PLEASE
 
  // da wir nicht genau wissen, ob der wirklich in diese richtung weiter
  // gelaufen ist, rechnen wir nur einen Teil...
  // for (int i=0; i<getAge(); i++) {
  //  pos.x =+ (CONFIDENCY * vel.x);
  //  pos.y =+ (CONFIDENCY * vel.y);
  // }

  // CMU estimatet schon. lassen wir das.
  
}

float AgingObject::sureness() { 
  return (isValid()?(float(MAX_AGE)/float(age)):0.0); 
}
void AgingObject::update(cmu::GameTime current) { 
  int temp = current.t - seenLast.t; age = temp; if (age > 0) estimate(); 
};
void BasicObject::set(cmu::GameTime current, cmu::Vector pos, cmu::Unum _unum /*, cmu::Vector & vel=0*/ ) 
{
  // seenVel = vel;
  unum = _unum;
  seenPos = pos; 
  seenLast = current;
  setXY(pos.x,pos.y); 
};
void BasicObject::set(cmu::GameTime current, cmu::Vector pos, float _dir, cmu::Unum _unum ) 
{
  this->set(current,pos,_unum);
  dir = _dir;
}
void BasicObject::set(cmu::GameTime current, int newX, int newY, float _dir, cmu::Unum _unum ) 
{
  unum = _unum;
  //seenPos = pos; 
  seenLast = current;
  dir = _dir;
  altesx = this->x;
  altesy = this->y;
  x = newX;
  y = newY;
}
void BallObject::set(cmu::GameTime current, cmu::Vector pos, float _dir ) 
{
  BasicObject::set(current,pos,-2);
  dir = _dir;
}

void BallObject::set(cmu::GameTime current,int newX, int newY, float _dir ) 
{
  BasicObject::set(current, newX, newY,_dir, -2);
}


/*
 * $Log: bugsobjects.cc,v $
 * Revision 1.7  2002/03/08 16:24:31  jens
 * Arbeiten beendet, die uns Potentialfeldszenen im Client parsen lassen und uns dann vollstaendige Potentialfelder genriert. Potentialfelder die generiert wurden und welche, die wir als Szene genommen haben (also die Feldwerte weglassen) stimmen nun ueberein. Rundungsfehler sind beseitigt. Somit sollte die Grundlage fuer die automatische Prioritaetenanpassung gelegt sein.
 *
 * Revision 1.6  2002/03/08 15:18:58  fastjack
 * Neue .set Methode eingefuehrt zum uebergeben von am Raster orientierten Koordinaten
 *
 * Revision 1.5  2002/03/01 11:18:48  fastjack
 * GPL added
 *
 * Revision 1.4  2002/02/05 13:41:07  fastjack
 * gemerged
 *
 * Revision 1.3  2002/01/28 11:42:03  fastjack
 * optimierungen
 *
 * Revision 1.2  2002/01/28 09:44:43  fastjack
 * link errors fixed
 *
 * Revision 1.1  2002/01/28 02:13:50  fastjack
 * Added an intermediary World object which should guess positions when it is done. Not ready yet, WARNING - code may or may not work.
 *
 */
